--------------------------------------------------------
-- Archivo creado  - domingo-junio-15-2014   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Procedure LLISTAT_GRUPS_PARTICI_PENDENT
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_GRUPS_PARTICI_PENDENT" (
  
  RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
  select  regals.ID_EVENT as event,articles.DESCRIPCIO,sum(transaccions.import)as IMPORT_INGRESSAT, 
  regals.import_acumulat - sum(transaccions.import)as import_restant, 
  round(sum(transaccions.import)*100/REGALS.IMPORT_acumulat,1) as percentatge_total
  from regals,transaccions,events_participants,desitjos,articles
  where CODI_ESTAT<>6
  and transaccions.ID_USUARI=events_participants.id_usuari
  and events_participants.id_event=regals.ID_EVENT
 and regals.id_desig=desitjos.ID
  and desitjos.CODI_ARTICLE=articles.CODI

 group by regals.id_event,articles.DESCRIPCIO,regals.IMPORT_acumulat;
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
  END LLISTAT_GRUPS_PARTICI_PENDENT;

/
--------------------------------------------------------
--  DDL for Procedure LLISTAT_PERSONES_SOBRE_MITJA
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_PERSONES_SOBRE_MITJA" 
 (
  v_id in  number
  ,RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
    SELECT USUARIS.NOM AS USUARIS 
  FROM USUARIS,TRANSACCIONS,EVENTS_PARTICIPANTS
  WHERE TRANSACCIONS.ID_USUARI=EVENTS_PARTICIPANTS.ID_USUARI
  and EVENTS_PARTICIPANTS.ID_EVENT=V_ID and transaccions.id_usuari=usuaris.ID
  AND TRANSACCIONS.IMPORT>(SELECT avg( TRANSACCIONS.import)
 from transaccions,EVENTS_PARTICIPANTS
  WHERE TRANSACCIONS.ID_USUARI=EVENTS_PARTICIPANTS.ID_USUARI AND
  EVENTS_PARTICIPANTS.ID_EVENT=V_ID) ; 
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
END LLISTAT_PERSONES_SOBRE_MITJA;

/
--------------------------------------------------------
--  DDL for Procedure LLISTAT_REGALS_CATEGORIA
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_REGALS_CATEGORIA" 
(
   v_id in  number
  ,RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
  select  DESCRIPCIO as DESCRIPCIO,CODI_PROVEIDOR AS PROVEIDOR
  from articles
  where CODI_CATEGORIA=v_id;
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
END LLISTAT_REGALS_CATEGORIA;

/
--------------------------------------------------------
--  DDL for Procedure LLISTAT_REGALS_DESITJATS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_REGALS_DESITJATS" (
  v_id in  number
  ,RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
  SELECT DESITJOS.CODI_PROV as PROVEIDOR,DESITJOS.DATA_ALTA AS DATA_ALTA,ARTICLES.DESCRIPCIO AS DESCRIPCIO,ARTICLES.PREU AS PREU
  FROM USUARIS,DESITJOS,ARTICLES
  where DESITJOS.ID_USUARI=V_ID AND DESITJOS.CODI_ARTICLE=ARTICLES.CODI
  GROUP BY DESITJOS.CODI_PROV, DESITJOS.DATA_ALTA,ARTICLES.DESCRIPCIO,ARTICLES.PREU;
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
  END LLISTAT_REGALS_DESITJATS;

/
--------------------------------------------------------
--  DDL for Procedure LLISTAT_REGALS_REBUTS_PARTICIP
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_REGALS_REBUTS_PARTICIP" 
(
  V_ID in  number
  ,RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
  select articles.DESCRIPCIO,regals_estat.DESCRIPCIO as ESTAT_DEL_PAQUET
from desitjos,regals,articles,regals_estat
where desitjos.ID_USUARI=V_ID
and desitjos.ID=regals.ID_DESIG
and desitjos.CODI_ARTICLE=articles.CODI
and regals.CODI_ESTAT=4
and regals.CODI_ESTAT=regals_estat.CODI
group by articles.Descripcio,regals_estat.DESCRIPCIO;
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
END LLISTAT_REGALS_REBUTS_PARTICIP;

/
--------------------------------------------------------
--  DDL for Procedure LLISTAT_10_CIUTATS_MES_REGALS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "REGALS"."LLISTAT_10_CIUTATS_MES_REGALS" (
  V_ID in  number
  ,RSP OUT VARCHAR2
  ,O_RESULT_SET OUT SYS_REFCURSOR
 
 
)
AS
 
BEGIN
   RSP:='OK'; -- PER DEFECTE OK
   
   O_RESULT_SET:=NULL;
   OPEN O_RESULT_SET FOR
  SELECT  USUARIS.POBLACIO,sum(transaccions.import)as suma_total, to_char(transaccions.data,'yyyy')as data
  FROM USUARIS,DESITJOS,REGALS,TRANSACCIONS
  WHERE TO_CHAR(TRANSACCIONS.DATA,'yyyy')=V_ID AND ROWNUM <=10 AND USUARIS.ID=DESITJOS.ID_USUARI AND DESITJOS.ID=REGALS.ID_DESIG
                    AND REGALS.ID=TRANSACCIONS.ID_REGAL AND REGALS.CODI_ESTAT=6 
  GROUP BY USUARIS.POBLACIO, to_char(transaccions.data,'yyyy')
  ORDER BY sum(transaccions.import) desc  ;
  
  EXCEPTION  -- SORTIDA SI SE HA PRODUIT UNA EXCEPCI
  WHEN OTHERS THEN RSP:='ERROR:'||SQLERRM;DBMS_OUTPUT.PUT_LINE(RSP);
  END LLISTAT_10_CIUTATS_MES_REGALS;

/
